<?php
/* --------------------------------------------------------------
   DeletedMultipleParcelServices.php 2020-03-30
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2020 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

declare(strict_types=1);

namespace Gambio\Admin\ParcelService\Events;

use Gambio\Admin\ParcelService\Interfaces\ParcelServiceIds;

/**
 * Class DeletedMultipleParcelServices
 *
 * @package Gambio\Admin\ParcelService\Events
 */
class DeletedMultipleParcelServices
{
    /**
     * @var ParcelServiceIds
     */
    private $parcelServiceIds;
    
    
    /**
     * DeletedMultipleParcelServicesEvent constructor.
     *
     * @param ParcelServiceIds $parcelServiceIds
     */
    private function __construct(ParcelServiceIds $parcelServiceIds)
    {
        $this->parcelServiceIds = $parcelServiceIds;
    }
    
    
    /**
     * @param ParcelServiceIds $parcelServiceIds
     *
     * @return DeletedMultipleParcelServices
     */
    public static function create(ParcelServiceIds $parcelServiceIds): DeletedMultipleParcelServices
    {
        return new self($parcelServiceIds);
    }
    
    
    /**
     * @return ParcelServiceIds
     */
    public function parcelServiceIds(): ParcelServiceIds
    {
        return $this->parcelServiceIds;
    }
}