<?php
/*----------------------------------------------------------
 OriginalImageUrl.php 2020-05-18
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 ---------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Shop\SellingUnit\Images\ValueObjects;

/**
 * Class OriginalImageUrl
 * @package Gambio\Shop\SellingUnit\Images\ValueObjects
 */
class OriginalImageUrl extends ImageUrl
{
    public function __construct(ImageUrl $popupUrl)
    {
        parent::__construct($this->originalImageUrlValue($popupUrl));
    }
    
    
    /**
     * @param ImageUrl $popupUrl
     *
     * @return string
     */
    protected function originalImageUrlValue(ImageUrl $popupUrl): string
    {
        $url      = $popupUrl->value();
        $pattern  = '#/popup_images/#';
        
        return preg_replace($pattern, '/original_images/', $url);
    }
}